/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsISVGGeometrySource.idl
 */

#ifndef __gen_nsISVGGeometrySource_h__
#define __gen_nsISVGGeometrySource_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
#include "nsColor.h"
class nsIDOMSVGMatrix; /* forward declaration */

class nsIPresContext; /* forward declaration */


/* starting interface:    nsISVGGeometrySource */
#define NS_ISVGGEOMETRYSOURCE_IID_STR "d65a8784-5382-4b68-848d-0a91cd096937"

#define NS_ISVGGEOMETRYSOURCE_IID \
  {0xd65a8784, 0x5382, 0x4b68, \
    { 0x84, 0x8d, 0x0a, 0x91, 0xcd, 0x09, 0x69, 0x37 }}

/**
 * \addtogroup rendering_backend_interfaces Rendering Backend Interfaces
 * @{
 */
/**
 * Describes a 'geometry' object (either a path or a glyph) in the SVG
 * rendering backend. The rendering backend maintains an object
 * implementing this interface for each rendering engine-native
 * geometry object.
 *
 * An engine-native geometry object will be informed of changes in a
 * geometry's description with a call to its 'update' method with an
 * OR-ed combination of the UPDATEMASK_* constants defined in this
 * interface (or one of its sub-interfaces).
 *
 * @nosubgrouping
 */
class NS_NO_VTABLE nsISVGGeometrySource : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_ISVGGEOMETRYSOURCE_IID)

  /**
   * @name Generic updatemasks
   * @{
   */
  enum { UPDATEMASK_NOTHING = 0U };

  enum { UPDATEMASK_ALL = 4294967295U };

  /** @} */
/**
   * @name Presentation context
   * @{
   */
  /* [noscript] readonly attribute nsIPresContext presContext; */
  NS_IMETHOD GetPresContext(nsIPresContext * *aPresContext) = 0;

  enum { UPDATEMASK_PRES_CONTEXT = 1U };

  /** @} */
/**
   * @name Current transform matrix
   * @{
   */
  /* readonly attribute nsIDOMSVGMatrix CTM; */
  NS_IMETHOD GetCTM(nsIDOMSVGMatrix * *aCTM) = 0;

  enum { UPDATEMASK_CTM = 2U };

  /** @} */
/**
   * @name Stroke opacity
   * @{
   */
  /* readonly attribute float strokeOpacity; */
  NS_IMETHOD GetStrokeOpacity(float *aStrokeOpacity) = 0;

  enum { UPDATEMASK_STROKE_OPACITY = 4U };

  /** @} */
/**
   * @name Stroke width
   * @{
   */
  /* readonly attribute float strokeWidth; */
  NS_IMETHOD GetStrokeWidth(float *aStrokeWidth) = 0;

  enum { UPDATEMASK_STROKE_WIDTH = 8U };

  /** @} */
/**
   * @name Stroke dash-array
   * @{
   */
  /* void getStrokeDashArray ([array, size_is (count)] out float arr, out unsigned long count); */
  NS_IMETHOD GetStrokeDashArray(float **arr, PRUint32 *count) = 0;

  enum { UPDATEMASK_STROKE_DASH_ARRAY = 16U };

  /** @} */
/**
   * @name Stroke dash-offset
   * @{
   */
  /* readonly attribute float strokeDashoffset; */
  NS_IMETHOD GetStrokeDashoffset(float *aStrokeDashoffset) = 0;

  enum { UPDATEMASK_STROKE_DASHOFFSET = 32U };

  /** @} */
/**
   * @name Stroke line-cap
   * @{
   */
  enum { STROKE_LINECAP_BUTT = 0U };

  enum { STROKE_LINECAP_ROUND = 1U };

  enum { STROKE_LINECAP_SQUARE = 2U };

  /* readonly attribute unsigned short strokeLinecap; */
  NS_IMETHOD GetStrokeLinecap(PRUint16 *aStrokeLinecap) = 0;

  enum { UPDATEMASK_STROKE_LINECAP = 64U };

  /** @} */
/**
   * @name Stroke line-join
   * @{
   */
  enum { STROKE_LINEJOIN_MITER = 0U };

  enum { STROKE_LINEJOIN_ROUND = 1U };

  enum { STROKE_LINEJOIN_BEVEL = 2U };

  /* readonly attribute unsigned short strokeLinejoin; */
  NS_IMETHOD GetStrokeLinejoin(PRUint16 *aStrokeLinejoin) = 0;

  enum { UPDATEMASK_STROKE_LINEJOIN = 128U };

  /** @} */
/**
   * @name Miterlimit
   * @{
   */
  /* readonly attribute float strokeMiterlimit; */
  NS_IMETHOD GetStrokeMiterlimit(float *aStrokeMiterlimit) = 0;

  enum { UPDATEMASK_STROKE_MITERLIMIT = 256U };

  /** @} */
/**
   * @name Fill opacity
   * @{
   */
  /* readonly attribute float fillOpacity; */
  NS_IMETHOD GetFillOpacity(float *aFillOpacity) = 0;

  enum { UPDATEMASK_FILL_OPACITY = 512U };

  /** @} */
/**
   * @name Fill rule
   * @{
   */
  enum { FILL_RULE_NONZERO = 0U };

  enum { FILL_RULE_EVENODD = 1U };

  /* readonly attribute unsigned short fillRule; */
  NS_IMETHOD GetFillRule(PRUint16 *aFillRule) = 0;

  enum { UPDATEMASK_FILL_RULE = 1024U };

  /** @} */
/**
   * @name Paint type constants for stroke and fill paint
   * @{
   */
  enum { PAINT_TYPE_NONE = 0U };

  enum { PAINT_TYPE_SOLID_COLOR = 1U };

  enum { PAINT_TYPE_SERVER = 2U };

  /** @} */
/**
   * @name Stroke paint
   * @{
   */
  /* readonly attribute unsigned short strokePaintType; */
  NS_IMETHOD GetStrokePaintType(PRUint16 *aStrokePaintType) = 0;

  enum { UPDATEMASK_STROKE_PAINT_TYPE = 2048U };

  /* [noscript] readonly attribute nscolor strokePaint; */
  NS_IMETHOD GetStrokePaint(nscolor *aStrokePaint) = 0;

  enum { UPDATEMASK_STROKE_PAINT = 4096U };

  /** @} */
/**
   * @name Fill paint
   * @{
   */
  /* readonly attribute unsigned short fillPaintType; */
  NS_IMETHOD GetFillPaintType(PRUint16 *aFillPaintType) = 0;

  enum { UPDATEMASK_FILL_PAINT_TYPE = 8192U };

  /* [noscript] readonly attribute nscolor fillPaint; */
  NS_IMETHOD GetFillPaint(nscolor *aFillPaint) = 0;

  enum { UPDATEMASK_FILL_PAINT = 16384U };

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSISVGGEOMETRYSOURCE \
  NS_IMETHOD GetPresContext(nsIPresContext * *aPresContext); \
  NS_IMETHOD GetCTM(nsIDOMSVGMatrix * *aCTM); \
  NS_IMETHOD GetStrokeOpacity(float *aStrokeOpacity); \
  NS_IMETHOD GetStrokeWidth(float *aStrokeWidth); \
  NS_IMETHOD GetStrokeDashArray(float **arr, PRUint32 *count); \
  NS_IMETHOD GetStrokeDashoffset(float *aStrokeDashoffset); \
  NS_IMETHOD GetStrokeLinecap(PRUint16 *aStrokeLinecap); \
  NS_IMETHOD GetStrokeLinejoin(PRUint16 *aStrokeLinejoin); \
  NS_IMETHOD GetStrokeMiterlimit(float *aStrokeMiterlimit); \
  NS_IMETHOD GetFillOpacity(float *aFillOpacity); \
  NS_IMETHOD GetFillRule(PRUint16 *aFillRule); \
  NS_IMETHOD GetStrokePaintType(PRUint16 *aStrokePaintType); \
  NS_IMETHOD GetStrokePaint(nscolor *aStrokePaint); \
  NS_IMETHOD GetFillPaintType(PRUint16 *aFillPaintType); \
  NS_IMETHOD GetFillPaint(nscolor *aFillPaint); \

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSISVGGEOMETRYSOURCE(_to) \
  NS_IMETHOD GetPresContext(nsIPresContext * *aPresContext) { return _to GetPresContext(aPresContext); } \
  NS_IMETHOD GetCTM(nsIDOMSVGMatrix * *aCTM) { return _to GetCTM(aCTM); } \
  NS_IMETHOD GetStrokeOpacity(float *aStrokeOpacity) { return _to GetStrokeOpacity(aStrokeOpacity); } \
  NS_IMETHOD GetStrokeWidth(float *aStrokeWidth) { return _to GetStrokeWidth(aStrokeWidth); } \
  NS_IMETHOD GetStrokeDashArray(float **arr, PRUint32 *count) { return _to GetStrokeDashArray(arr, count); } \
  NS_IMETHOD GetStrokeDashoffset(float *aStrokeDashoffset) { return _to GetStrokeDashoffset(aStrokeDashoffset); } \
  NS_IMETHOD GetStrokeLinecap(PRUint16 *aStrokeLinecap) { return _to GetStrokeLinecap(aStrokeLinecap); } \
  NS_IMETHOD GetStrokeLinejoin(PRUint16 *aStrokeLinejoin) { return _to GetStrokeLinejoin(aStrokeLinejoin); } \
  NS_IMETHOD GetStrokeMiterlimit(float *aStrokeMiterlimit) { return _to GetStrokeMiterlimit(aStrokeMiterlimit); } \
  NS_IMETHOD GetFillOpacity(float *aFillOpacity) { return _to GetFillOpacity(aFillOpacity); } \
  NS_IMETHOD GetFillRule(PRUint16 *aFillRule) { return _to GetFillRule(aFillRule); } \
  NS_IMETHOD GetStrokePaintType(PRUint16 *aStrokePaintType) { return _to GetStrokePaintType(aStrokePaintType); } \
  NS_IMETHOD GetStrokePaint(nscolor *aStrokePaint) { return _to GetStrokePaint(aStrokePaint); } \
  NS_IMETHOD GetFillPaintType(PRUint16 *aFillPaintType) { return _to GetFillPaintType(aFillPaintType); } \
  NS_IMETHOD GetFillPaint(nscolor *aFillPaint) { return _to GetFillPaint(aFillPaint); } \

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSISVGGEOMETRYSOURCE(_to) \
  NS_IMETHOD GetPresContext(nsIPresContext * *aPresContext) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPresContext(aPresContext); } \
  NS_IMETHOD GetCTM(nsIDOMSVGMatrix * *aCTM) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCTM(aCTM); } \
  NS_IMETHOD GetStrokeOpacity(float *aStrokeOpacity) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStrokeOpacity(aStrokeOpacity); } \
  NS_IMETHOD GetStrokeWidth(float *aStrokeWidth) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStrokeWidth(aStrokeWidth); } \
  NS_IMETHOD GetStrokeDashArray(float **arr, PRUint32 *count) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStrokeDashArray(arr, count); } \
  NS_IMETHOD GetStrokeDashoffset(float *aStrokeDashoffset) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStrokeDashoffset(aStrokeDashoffset); } \
  NS_IMETHOD GetStrokeLinecap(PRUint16 *aStrokeLinecap) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStrokeLinecap(aStrokeLinecap); } \
  NS_IMETHOD GetStrokeLinejoin(PRUint16 *aStrokeLinejoin) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStrokeLinejoin(aStrokeLinejoin); } \
  NS_IMETHOD GetStrokeMiterlimit(float *aStrokeMiterlimit) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStrokeMiterlimit(aStrokeMiterlimit); } \
  NS_IMETHOD GetFillOpacity(float *aFillOpacity) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFillOpacity(aFillOpacity); } \
  NS_IMETHOD GetFillRule(PRUint16 *aFillRule) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFillRule(aFillRule); } \
  NS_IMETHOD GetStrokePaintType(PRUint16 *aStrokePaintType) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStrokePaintType(aStrokePaintType); } \
  NS_IMETHOD GetStrokePaint(nscolor *aStrokePaint) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStrokePaint(aStrokePaint); } \
  NS_IMETHOD GetFillPaintType(PRUint16 *aFillPaintType) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFillPaintType(aFillPaintType); } \
  NS_IMETHOD GetFillPaint(nscolor *aFillPaint) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFillPaint(aFillPaint); } \

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsSVGGeometrySource : public nsISVGGeometrySource
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSISVGGEOMETRYSOURCE

  nsSVGGeometrySource();

private:
  ~nsSVGGeometrySource();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsSVGGeometrySource, nsISVGGeometrySource)

nsSVGGeometrySource::nsSVGGeometrySource()
{
  /* member initializers and constructor code */
}

nsSVGGeometrySource::~nsSVGGeometrySource()
{
  /* destructor code */
}

/* [noscript] readonly attribute nsIPresContext presContext; */
NS_IMETHODIMP nsSVGGeometrySource::GetPresContext(nsIPresContext * *aPresContext)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIDOMSVGMatrix CTM; */
NS_IMETHODIMP nsSVGGeometrySource::GetCTM(nsIDOMSVGMatrix * *aCTM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute float strokeOpacity; */
NS_IMETHODIMP nsSVGGeometrySource::GetStrokeOpacity(float *aStrokeOpacity)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute float strokeWidth; */
NS_IMETHODIMP nsSVGGeometrySource::GetStrokeWidth(float *aStrokeWidth)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getStrokeDashArray ([array, size_is (count)] out float arr, out unsigned long count); */
NS_IMETHODIMP nsSVGGeometrySource::GetStrokeDashArray(float **arr, PRUint32 *count)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute float strokeDashoffset; */
NS_IMETHODIMP nsSVGGeometrySource::GetStrokeDashoffset(float *aStrokeDashoffset)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned short strokeLinecap; */
NS_IMETHODIMP nsSVGGeometrySource::GetStrokeLinecap(PRUint16 *aStrokeLinecap)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned short strokeLinejoin; */
NS_IMETHODIMP nsSVGGeometrySource::GetStrokeLinejoin(PRUint16 *aStrokeLinejoin)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute float strokeMiterlimit; */
NS_IMETHODIMP nsSVGGeometrySource::GetStrokeMiterlimit(float *aStrokeMiterlimit)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute float fillOpacity; */
NS_IMETHODIMP nsSVGGeometrySource::GetFillOpacity(float *aFillOpacity)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned short fillRule; */
NS_IMETHODIMP nsSVGGeometrySource::GetFillRule(PRUint16 *aFillRule)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned short strokePaintType; */
NS_IMETHODIMP nsSVGGeometrySource::GetStrokePaintType(PRUint16 *aStrokePaintType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] readonly attribute nscolor strokePaint; */
NS_IMETHODIMP nsSVGGeometrySource::GetStrokePaint(nscolor *aStrokePaint)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned short fillPaintType; */
NS_IMETHODIMP nsSVGGeometrySource::GetFillPaintType(PRUint16 *aFillPaintType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] readonly attribute nscolor fillPaint; */
NS_IMETHODIMP nsSVGGeometrySource::GetFillPaint(nscolor *aFillPaint)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsISVGGeometrySource_h__ */
