/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIMsgComposeService.idl
 */

#ifndef __gen_nsIMsgComposeService_h__
#define __gen_nsIMsgComposeService_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIMsgCompose_h__
#include "nsIMsgCompose.h"
#endif

#ifndef __gen_nsIMsgComposeParams_h__
#include "nsIMsgComposeParams.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIURI; /* forward declaration */

class nsIDOMWindowInternal; /* forward declaration */

class nsIMsgWindow; /* forward declaration */

class nsIMsgIdentity; /* forward declaration */


/* starting interface:    nsIMsgComposeService */
#define NS_IMSGCOMPOSESERVICE_IID_STR "b004f4ae-1ac2-11d3-a715-0060b0eb39b5"

#define NS_IMSGCOMPOSESERVICE_IID \
  {0xb004f4ae, 0x1ac2, 0x11d3, \
    { 0xa7, 0x15, 0x00, 0x60, 0xb0, 0xeb, 0x39, 0xb5 }}

class NS_NO_VTABLE nsIMsgComposeService : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IMSGCOMPOSESERVICE_IID)

  /* void OpenComposeWindow (in string msgComposeWindowURL, in string originalMsgURI, in MSG_ComposeType type, in MSG_ComposeFormat format, in nsIMsgIdentity identity, in nsIMsgWindow aMsgWindow); */
  NS_IMETHOD OpenComposeWindow(const char *msgComposeWindowURL, const char *originalMsgURI, MSG_ComposeType type, MSG_ComposeFormat format, nsIMsgIdentity *identity, nsIMsgWindow *aMsgWindow) = 0;

  /* void OpenComposeWindowWithURI (in string msgComposeWindowURL, in nsIURI aURI); */
  NS_IMETHOD OpenComposeWindowWithURI(const char *msgComposeWindowURL, nsIURI *aURI) = 0;

  /**
  * OpenComposeWindowWithValues
  *
  * @NOT SUPPORTED ANYMORE, USE OpenComposeWindowWithParams INSTEAD.
  * @THIS API WILL BE REMOVED
  */
  /* void OpenComposeWindowWithValues (in string msgComposeWindowURL, in MSG_ComposeType type, in MSG_ComposeFormat format, in wstring to, in wstring cc, in wstring bcc, in string newsgroups, in wstring subject, in wstring body, in string attachment, in nsIMsgIdentity identity); */
  NS_IMETHOD OpenComposeWindowWithValues(const char *msgComposeWindowURL, MSG_ComposeType type, MSG_ComposeFormat format, const PRUnichar *to, const PRUnichar *cc, const PRUnichar *bcc, const char *newsgroups, const PRUnichar *subject, const PRUnichar *body, const char *attachment, nsIMsgIdentity *identity) = 0;

  /**
  * OpenComposeWindowWithCompFields
  *
  * @NOT SUPPORTED ANYMORE, USE OpenComposeWindowWithParams INSTEAD.
  * @THIS API WILL BE REMOVED
  */
  /* void OpenComposeWindowWithCompFields (in string msgComposeWindowURL, in MSG_ComposeType type, in MSG_ComposeFormat format, in nsIMsgCompFields compFields, in nsIMsgIdentity identity); */
  NS_IMETHOD OpenComposeWindowWithCompFields(const char *msgComposeWindowURL, MSG_ComposeType type, MSG_ComposeFormat format, nsIMsgCompFields *compFields, nsIMsgIdentity *identity) = 0;

  /* void OpenComposeWindowWithParams (in string msgComposeWindowURL, in nsIMsgComposeParams params); */
  NS_IMETHOD OpenComposeWindowWithParams(const char *msgComposeWindowURL, nsIMsgComposeParams *params) = 0;

  /* nsIMsgCompose InitCompose (in nsIDOMWindowInternal aWindow, in nsIMsgComposeParams params); */
  NS_IMETHOD InitCompose(nsIDOMWindowInternal *aWindow, nsIMsgComposeParams *params, nsIMsgCompose **_retval) = 0;

  /**
  * defaultIdentity
  *
  * @return the default identity, in case no identity has been setup yet, will return null
  */
  /* readonly attribute nsIMsgIdentity defaultIdentity; */
  NS_IMETHOD GetDefaultIdentity(nsIMsgIdentity * *aDefaultIdentity) = 0;

  /* void TimeStamp (in string label, in boolean resetTime); */
  NS_IMETHOD TimeStamp(const char *label, PRBool resetTime) = 0;

  /* readonly attribute boolean logComposePerformance; */
  NS_IMETHOD GetLogComposePerformance(PRBool *aLogComposePerformance) = 0;

  /* [noscript] boolean determineComposeHTML (in nsIMsgIdentity aIdentity, in MSG_ComposeFormat aFormat); */
  NS_IMETHOD DetermineComposeHTML(nsIMsgIdentity *aIdentity, MSG_ComposeFormat aFormat, PRBool *_retval) = 0;

  /* [noscript] void cacheWindow (in nsIDOMWindowInternal aWindow, in boolean aComposeHTML, in nsIMsgComposeRecyclingListener listener); */
  NS_IMETHOD CacheWindow(nsIDOMWindowInternal *aWindow, PRBool aComposeHTML, nsIMsgComposeRecyclingListener *listener) = 0;

  /* boolean isCachedWindow (in nsIDOMWindowInternal aWindow); */
  NS_IMETHOD IsCachedWindow(nsIDOMWindowInternal *aWindow, PRBool *_retval) = 0;

  /** 
   * given a mailto url, parse the attributes and turn them into a nsIMsgComposeParams object
   * @return nsIMsgComposeParams which corresponds to the passed in mailto url
   */
  /* nsIMsgComposeParams getParamsForMailto (in nsIURI aURI); */
  NS_IMETHOD GetParamsForMailto(nsIURI *aURI, nsIMsgComposeParams **_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIMSGCOMPOSESERVICE \
  NS_IMETHOD OpenComposeWindow(const char *msgComposeWindowURL, const char *originalMsgURI, MSG_ComposeType type, MSG_ComposeFormat format, nsIMsgIdentity *identity, nsIMsgWindow *aMsgWindow); \
  NS_IMETHOD OpenComposeWindowWithURI(const char *msgComposeWindowURL, nsIURI *aURI); \
  NS_IMETHOD OpenComposeWindowWithValues(const char *msgComposeWindowURL, MSG_ComposeType type, MSG_ComposeFormat format, const PRUnichar *to, const PRUnichar *cc, const PRUnichar *bcc, const char *newsgroups, const PRUnichar *subject, const PRUnichar *body, const char *attachment, nsIMsgIdentity *identity); \
  NS_IMETHOD OpenComposeWindowWithCompFields(const char *msgComposeWindowURL, MSG_ComposeType type, MSG_ComposeFormat format, nsIMsgCompFields *compFields, nsIMsgIdentity *identity); \
  NS_IMETHOD OpenComposeWindowWithParams(const char *msgComposeWindowURL, nsIMsgComposeParams *params); \
  NS_IMETHOD InitCompose(nsIDOMWindowInternal *aWindow, nsIMsgComposeParams *params, nsIMsgCompose **_retval); \
  NS_IMETHOD GetDefaultIdentity(nsIMsgIdentity * *aDefaultIdentity); \
  NS_IMETHOD TimeStamp(const char *label, PRBool resetTime); \
  NS_IMETHOD GetLogComposePerformance(PRBool *aLogComposePerformance); \
  NS_IMETHOD DetermineComposeHTML(nsIMsgIdentity *aIdentity, MSG_ComposeFormat aFormat, PRBool *_retval); \
  NS_IMETHOD CacheWindow(nsIDOMWindowInternal *aWindow, PRBool aComposeHTML, nsIMsgComposeRecyclingListener *listener); \
  NS_IMETHOD IsCachedWindow(nsIDOMWindowInternal *aWindow, PRBool *_retval); \
  NS_IMETHOD GetParamsForMailto(nsIURI *aURI, nsIMsgComposeParams **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIMSGCOMPOSESERVICE(_to) \
  NS_IMETHOD OpenComposeWindow(const char *msgComposeWindowURL, const char *originalMsgURI, MSG_ComposeType type, MSG_ComposeFormat format, nsIMsgIdentity *identity, nsIMsgWindow *aMsgWindow) { return _to OpenComposeWindow(msgComposeWindowURL, originalMsgURI, type, format, identity, aMsgWindow); } \
  NS_IMETHOD OpenComposeWindowWithURI(const char *msgComposeWindowURL, nsIURI *aURI) { return _to OpenComposeWindowWithURI(msgComposeWindowURL, aURI); } \
  NS_IMETHOD OpenComposeWindowWithValues(const char *msgComposeWindowURL, MSG_ComposeType type, MSG_ComposeFormat format, const PRUnichar *to, const PRUnichar *cc, const PRUnichar *bcc, const char *newsgroups, const PRUnichar *subject, const PRUnichar *body, const char *attachment, nsIMsgIdentity *identity) { return _to OpenComposeWindowWithValues(msgComposeWindowURL, type, format, to, cc, bcc, newsgroups, subject, body, attachment, identity); } \
  NS_IMETHOD OpenComposeWindowWithCompFields(const char *msgComposeWindowURL, MSG_ComposeType type, MSG_ComposeFormat format, nsIMsgCompFields *compFields, nsIMsgIdentity *identity) { return _to OpenComposeWindowWithCompFields(msgComposeWindowURL, type, format, compFields, identity); } \
  NS_IMETHOD OpenComposeWindowWithParams(const char *msgComposeWindowURL, nsIMsgComposeParams *params) { return _to OpenComposeWindowWithParams(msgComposeWindowURL, params); } \
  NS_IMETHOD InitCompose(nsIDOMWindowInternal *aWindow, nsIMsgComposeParams *params, nsIMsgCompose **_retval) { return _to InitCompose(aWindow, params, _retval); } \
  NS_IMETHOD GetDefaultIdentity(nsIMsgIdentity * *aDefaultIdentity) { return _to GetDefaultIdentity(aDefaultIdentity); } \
  NS_IMETHOD TimeStamp(const char *label, PRBool resetTime) { return _to TimeStamp(label, resetTime); } \
  NS_IMETHOD GetLogComposePerformance(PRBool *aLogComposePerformance) { return _to GetLogComposePerformance(aLogComposePerformance); } \
  NS_IMETHOD DetermineComposeHTML(nsIMsgIdentity *aIdentity, MSG_ComposeFormat aFormat, PRBool *_retval) { return _to DetermineComposeHTML(aIdentity, aFormat, _retval); } \
  NS_IMETHOD CacheWindow(nsIDOMWindowInternal *aWindow, PRBool aComposeHTML, nsIMsgComposeRecyclingListener *listener) { return _to CacheWindow(aWindow, aComposeHTML, listener); } \
  NS_IMETHOD IsCachedWindow(nsIDOMWindowInternal *aWindow, PRBool *_retval) { return _to IsCachedWindow(aWindow, _retval); } \
  NS_IMETHOD GetParamsForMailto(nsIURI *aURI, nsIMsgComposeParams **_retval) { return _to GetParamsForMailto(aURI, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIMSGCOMPOSESERVICE(_to) \
  NS_IMETHOD OpenComposeWindow(const char *msgComposeWindowURL, const char *originalMsgURI, MSG_ComposeType type, MSG_ComposeFormat format, nsIMsgIdentity *identity, nsIMsgWindow *aMsgWindow) { return !_to ? NS_ERROR_NULL_POINTER : _to->OpenComposeWindow(msgComposeWindowURL, originalMsgURI, type, format, identity, aMsgWindow); } \
  NS_IMETHOD OpenComposeWindowWithURI(const char *msgComposeWindowURL, nsIURI *aURI) { return !_to ? NS_ERROR_NULL_POINTER : _to->OpenComposeWindowWithURI(msgComposeWindowURL, aURI); } \
  NS_IMETHOD OpenComposeWindowWithValues(const char *msgComposeWindowURL, MSG_ComposeType type, MSG_ComposeFormat format, const PRUnichar *to, const PRUnichar *cc, const PRUnichar *bcc, const char *newsgroups, const PRUnichar *subject, const PRUnichar *body, const char *attachment, nsIMsgIdentity *identity) { return !_to ? NS_ERROR_NULL_POINTER : _to->OpenComposeWindowWithValues(msgComposeWindowURL, type, format, to, cc, bcc, newsgroups, subject, body, attachment, identity); } \
  NS_IMETHOD OpenComposeWindowWithCompFields(const char *msgComposeWindowURL, MSG_ComposeType type, MSG_ComposeFormat format, nsIMsgCompFields *compFields, nsIMsgIdentity *identity) { return !_to ? NS_ERROR_NULL_POINTER : _to->OpenComposeWindowWithCompFields(msgComposeWindowURL, type, format, compFields, identity); } \
  NS_IMETHOD OpenComposeWindowWithParams(const char *msgComposeWindowURL, nsIMsgComposeParams *params) { return !_to ? NS_ERROR_NULL_POINTER : _to->OpenComposeWindowWithParams(msgComposeWindowURL, params); } \
  NS_IMETHOD InitCompose(nsIDOMWindowInternal *aWindow, nsIMsgComposeParams *params, nsIMsgCompose **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->InitCompose(aWindow, params, _retval); } \
  NS_IMETHOD GetDefaultIdentity(nsIMsgIdentity * *aDefaultIdentity) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDefaultIdentity(aDefaultIdentity); } \
  NS_IMETHOD TimeStamp(const char *label, PRBool resetTime) { return !_to ? NS_ERROR_NULL_POINTER : _to->TimeStamp(label, resetTime); } \
  NS_IMETHOD GetLogComposePerformance(PRBool *aLogComposePerformance) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLogComposePerformance(aLogComposePerformance); } \
  NS_IMETHOD DetermineComposeHTML(nsIMsgIdentity *aIdentity, MSG_ComposeFormat aFormat, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->DetermineComposeHTML(aIdentity, aFormat, _retval); } \
  NS_IMETHOD CacheWindow(nsIDOMWindowInternal *aWindow, PRBool aComposeHTML, nsIMsgComposeRecyclingListener *listener) { return !_to ? NS_ERROR_NULL_POINTER : _to->CacheWindow(aWindow, aComposeHTML, listener); } \
  NS_IMETHOD IsCachedWindow(nsIDOMWindowInternal *aWindow, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsCachedWindow(aWindow, _retval); } \
  NS_IMETHOD GetParamsForMailto(nsIURI *aURI, nsIMsgComposeParams **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetParamsForMailto(aURI, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsMsgComposeService : public nsIMsgComposeService
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIMSGCOMPOSESERVICE

  nsMsgComposeService();

private:
  ~nsMsgComposeService();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsMsgComposeService, nsIMsgComposeService)

nsMsgComposeService::nsMsgComposeService()
{
  /* member initializers and constructor code */
}

nsMsgComposeService::~nsMsgComposeService()
{
  /* destructor code */
}

/* void OpenComposeWindow (in string msgComposeWindowURL, in string originalMsgURI, in MSG_ComposeType type, in MSG_ComposeFormat format, in nsIMsgIdentity identity, in nsIMsgWindow aMsgWindow); */
NS_IMETHODIMP nsMsgComposeService::OpenComposeWindow(const char *msgComposeWindowURL, const char *originalMsgURI, MSG_ComposeType type, MSG_ComposeFormat format, nsIMsgIdentity *identity, nsIMsgWindow *aMsgWindow)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void OpenComposeWindowWithURI (in string msgComposeWindowURL, in nsIURI aURI); */
NS_IMETHODIMP nsMsgComposeService::OpenComposeWindowWithURI(const char *msgComposeWindowURL, nsIURI *aURI)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void OpenComposeWindowWithValues (in string msgComposeWindowURL, in MSG_ComposeType type, in MSG_ComposeFormat format, in wstring to, in wstring cc, in wstring bcc, in string newsgroups, in wstring subject, in wstring body, in string attachment, in nsIMsgIdentity identity); */
NS_IMETHODIMP nsMsgComposeService::OpenComposeWindowWithValues(const char *msgComposeWindowURL, MSG_ComposeType type, MSG_ComposeFormat format, const PRUnichar *to, const PRUnichar *cc, const PRUnichar *bcc, const char *newsgroups, const PRUnichar *subject, const PRUnichar *body, const char *attachment, nsIMsgIdentity *identity)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void OpenComposeWindowWithCompFields (in string msgComposeWindowURL, in MSG_ComposeType type, in MSG_ComposeFormat format, in nsIMsgCompFields compFields, in nsIMsgIdentity identity); */
NS_IMETHODIMP nsMsgComposeService::OpenComposeWindowWithCompFields(const char *msgComposeWindowURL, MSG_ComposeType type, MSG_ComposeFormat format, nsIMsgCompFields *compFields, nsIMsgIdentity *identity)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void OpenComposeWindowWithParams (in string msgComposeWindowURL, in nsIMsgComposeParams params); */
NS_IMETHODIMP nsMsgComposeService::OpenComposeWindowWithParams(const char *msgComposeWindowURL, nsIMsgComposeParams *params)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIMsgCompose InitCompose (in nsIDOMWindowInternal aWindow, in nsIMsgComposeParams params); */
NS_IMETHODIMP nsMsgComposeService::InitCompose(nsIDOMWindowInternal *aWindow, nsIMsgComposeParams *params, nsIMsgCompose **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIMsgIdentity defaultIdentity; */
NS_IMETHODIMP nsMsgComposeService::GetDefaultIdentity(nsIMsgIdentity * *aDefaultIdentity)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void TimeStamp (in string label, in boolean resetTime); */
NS_IMETHODIMP nsMsgComposeService::TimeStamp(const char *label, PRBool resetTime)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean logComposePerformance; */
NS_IMETHODIMP nsMsgComposeService::GetLogComposePerformance(PRBool *aLogComposePerformance)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] boolean determineComposeHTML (in nsIMsgIdentity aIdentity, in MSG_ComposeFormat aFormat); */
NS_IMETHODIMP nsMsgComposeService::DetermineComposeHTML(nsIMsgIdentity *aIdentity, MSG_ComposeFormat aFormat, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] void cacheWindow (in nsIDOMWindowInternal aWindow, in boolean aComposeHTML, in nsIMsgComposeRecyclingListener listener); */
NS_IMETHODIMP nsMsgComposeService::CacheWindow(nsIDOMWindowInternal *aWindow, PRBool aComposeHTML, nsIMsgComposeRecyclingListener *listener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isCachedWindow (in nsIDOMWindowInternal aWindow); */
NS_IMETHODIMP nsMsgComposeService::IsCachedWindow(nsIDOMWindowInternal *aWindow, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIMsgComposeParams getParamsForMailto (in nsIURI aURI); */
NS_IMETHODIMP nsMsgComposeService::GetParamsForMailto(nsIURI *aURI, nsIMsgComposeParams **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIMsgComposeService_h__ */
